"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = require("fs-extra");
var rfs = require("rotating-file-stream");
var path_1 = require("path");
var FileWriter = /** @class */ (function () {
    function FileWriter(path, interval) {
        if (interval) {
            var dir = path_1.dirname(path);
            var file = path_1.basename(path);
            fs_extra_1.ensureDirSync(dir);
            this._stream = rfs(file, {
                interval: interval,
                path: dir,
            });
        }
        else {
            var dir = path_1.dirname(path);
            fs_extra_1.ensureDirSync(dir);
            this._stream = fs_extra_1.createWriteStream(path, {
                flags: 'a',
            });
        }
    }
    FileWriter.prototype._message = function (type, msg) {
        this._stream.write("\n" + type + ": " + msg);
    };
    FileWriter.prototype.log = function (msg) {
        this._message('log', msg);
    };
    FileWriter.prototype.error = function (msg) {
        this._message('err', msg);
    };
    return FileWriter;
}());
exports.FileWriter = FileWriter;
exports.default = FileWriter;

//# sourceMappingURL=index.js.map
