"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fecha = require("fecha");
var DefaultWriter = /** @class */ (function () {
    function DefaultWriter() {
    }
    DefaultWriter.prototype.log = function (msg) {
        console.log(msg);
        if (this._other) {
            this._other.log(msg);
        }
    };
    DefaultWriter.prototype.error = function (msg) {
        console.log(msg);
        if (this._other) {
            this._other.error(msg);
        }
    };
    Object.defineProperty(DefaultWriter.prototype, "link", {
        set: function (other) {
            this._other = other;
        },
        enumerable: true,
        configurable: true
    });
    return DefaultWriter;
}());
fecha.masks.myMask = 'YYYY-MM-DD HH:mm:ss.SSS';
var _writer = new DefaultWriter();
var Logger = /** @class */ (function () {
    function Logger(name) {
        this.name = name;
    }
    Object.defineProperty(Logger, "writer", {
        get: function () {
            return _writer;
        },
        set: function (writer) {
            _writer = writer;
        },
        enumerable: true,
        configurable: true
    });
    Logger.prototype._makeMsg = function (msgs) {
        var time = fecha.format(new Date(), 'myMask');
        if (this.name) {
            return time + " > " + this.name + " - " + msgs.join(' ');
        }
        else {
            return time + " > " + msgs.join(' ');
        }
    };
    Logger.prototype.log = function () {
        var msgs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            msgs[_i] = arguments[_i];
        }
        var msg = this._makeMsg(msgs);
        if (Logger.writer) {
            Logger.writer.log(msg);
        }
    };
    Logger.prototype.error = function () {
        var msgs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            msgs[_i] = arguments[_i];
        }
        var msg = this._makeMsg(msgs);
        if (Logger.writer) {
            Logger.writer.error(msg);
        }
    };
    return Logger;
}());
exports.Logger = Logger;
exports.default = Logger;

//# sourceMappingURL=index.js.map
