"use strict";
// promisify
//
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Callback 방식을 Promise 로 변환
 */
function promisify(func, hasErr, ctx) {
    if (hasErr === void 0) { hasErr = true; }
    if (ctx === void 0) { ctx = undefined; }
    if (typeof hasErr !== 'boolean') {
        _a = [ctx, hasErr], hasErr = _a[0], ctx = _a[1];
        if (hasErr === undefined) {
            hasErr = true;
        }
    }
    if (typeof hasErr !== 'boolean') {
        throw new Error('argument 전달이 잘못됐다.');
    }
    return function () {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return new Promise(function (resolve, reject) {
            var ff = func.bind((ctx !== undefined) ? ctx : _this);
            try {
                ff.apply(void 0, args.concat([function (err) {
                        var args = [];
                        for (var _i = 1; _i < arguments.length; _i++) {
                            args[_i - 1] = arguments[_i];
                        }
                        if (hasErr && err) {
                            reject(err);
                        }
                        else if (hasErr) {
                            resolve((args.length <= 1) ? args[0] : args.slice());
                        }
                        else {
                            resolve((args.length == 0) ? err : [err].concat(args));
                        }
                    }]));
            }
            catch (err) {
                if (hasErr) {
                    reject(err);
                }
                else {
                    throw err;
                }
            }
        });
    };
    var _a;
}
exports.promisify = promisify;
exports.default = promisify;

//# sourceMappingURL=index.js.map
